// I don't wrap this in an `ifndef `define `endif block as I want to detect
// double inclusion of a package. Double inclusion is either a small
// performance problem or a namespace collision which is a medium scale
// problem. I both cases I want my simulator to flag this problem.

`include "definitions.svh"
`include "dpcm_if.sv"

// Including uvm_macros.svh instead of uvm.sv and putting packages on the
// command line improves compile time performance by avoiding recompiles.
`include "uvm_macros.svh"

package dpcm_pkg;

  import uvm_pkg::*;
  import basic_pkg::*;

  typedef virtual dpcm_if dpcm_vif;
  
  `include "dpcm_tr.sv"

  // There is no difference between a passive master agent and a slave agent, so there is only one agent
  `include "dpcm_agent.sv"  

  `include "dpcm_cov_lib.sv"
endpackage
