
`include "definitions.svh"

import lpcm_pkg::*;
import dpcm_pkg::*;
import uvm_pkg::*;

`include "tb_test_lib.sv"

`include "dut.v"

module top;
  
  logic clk = 0;
  logic resetb;
  always #5 clk = !clk;
  initial begin
    resetb = 0;
    #22 resetb = 1;
  end
  
  lpcm_if pcm_mst_if(clk, resetb);
  dpcm_if pcm_slv_if(clk, resetb);

  dut #(`LPCM_SIZE, `DPCM_SIZE) dut
    (.clk(clk),
     .resetb(resetb),
     .en_in(pcm_mst_if.en),
     .data_in(pcm_mst_if.data),
     .en_out(pcm_slv_if.en),
     .data_out(pcm_slv_if.data));
  

  initial begin
    `ifdef INCA
       $recordvars();
    `endif
    `ifdef VCS
       $vcdpluson;
    `endif
    `ifdef QUESTA
       $wlfdumpvars();
       set_config_int("*", "recording_detail", 1);
    `endif
    // Connect interfaces to agents inside the environment
    uvm_config_db#(lpcm_vif)::set(null, "uvm_test_top.tb_env.master.*", "vif", pcm_mst_if);
    uvm_config_db#(dpcm_vif)::set(null, "uvm_test_top.tb_env.slave.*",  "vif", pcm_slv_if);
    run_test();
  end
endmodule

